#include "include.h"
#include "net_descricao.h"

/* STRUCT de coisas para connect() que eh usada em mais de 1 funcao  */ 
struct sockaddr_in tredi_sini;
struct hostent *tredi_he;

/* From the list program, to deal with it */
extern GtkWidget *ctree;
extern GtkWidget *tela;
extern GtkWidget *parar;

/* To deal with the list program, while trying to connect */
int okay = 0;
extern int telaaberta;

/* From the main window program */
extern int numport;

int
scan_connect(char *nome_host)
{

  /* Crio uma array de pthread_t para criar qtas for preciso */
  /* Arrumo o HOSTNAME, crio as threads, faco com o programa */
  /* Nao espere as threads retornarem para que o GTK possa criar */
  /* a outra janela sem esperar tudo terminar ... */

  int i, sockfd;
  int soki[NUM_THREAD];
  pthread_t tredi[NUM_THREAD];

  if((tredi_he = gethostbyname(nome_host)) == NULL) {
    errotela("Name could not be resolved!");
    return -1;
  }
  
  for(i=0;i<NUM_THREAD;i++)
    pthread_create(&tredi[i], NULL, (void *)escaneia, (void *)i);
  
  for(i=0;i<NUM_THREAD;i++)
    pthread_detach(tredi[i]); 
}

int
nonblocking_connect(int sockfd, struct sockaddr *sini, int size)
{
  
  /* Com select, essa funcao seta o timeout pra um */
  /* NONBLOCKING connect para 1 segundo, se sua conexao */
  /* For tao lenta.. que o ping estiver acima de 1 segundo */
  /* Capaz que nao funcione */

  int flags, iupi, ieba, erro, erros;
  fd_set rset, wset;
  struct timeval tempu;
  
  flags = fcntl(sockfd, F_GETFL,0);
  fcntl(sockfd, F_SETFL, flags | O_NONBLOCK);
  
  iupi = connect(sockfd, (struct sockaddr *)sini, size);
  if(iupi < 0 && errno != EINPROGRESS)
    return(-1);
  
  FD_ZERO(&rset);
  FD_SET(sockfd, &rset);
  wset = rset;
  tempu.tv_sec = 1;
  tempu.tv_usec = 0;
  
  
  if((ieba = select(sockfd + 1, &rset, &wset, NULL,
		    1 ? &tempu : NULL)) == 0) {    
    errno = ETIMEDOUT;
    return(-1);
  }
  
  if(FD_ISSET(sockfd, &rset) || FD_ISSET(sockfd, &wset)) {
    erros = sizeof(erro);
    if(getsockopt(sockfd, SOL_SOCKET, SO_ERROR, &erro, &erros)<0)
      return(-1);
  }
  
 done:
  fcntl(sockfd, F_SETFL, flags);
  
  if(erro)
    return(-1);
  else
    return(0);
  
}

void
escaneia(int i) {
  
  int sockfd, j, l=0;
  
  for(j=(numport/NUM_THREAD)*(i)+1;j<(numport/NUM_THREAD)*(i+1)+1;j++,l++) {
    
    bzero(&tredi_sini, sizeof(tredi_sini));
    tredi_sini.sin_family = AF_INET;
    tredi_sini.sin_port = htons(j);
    bcopy(tredi_he->h_addr, &tredi_sini.sin_addr.s_addr, tredi_he->h_length);
    
    sockfd = socket(AF_INET, SOCK_STREAM, 0);
    
    if((nonblocking_connect(sockfd, (struct sockaddr *)&tredi_sini, sizeof(tredi_sini)))==0)
      aberta(j);
    
    close(sockfd);
  }
  
  /* okay eh uma variavel global, assim como telaaberta */
  /* se telaaberta for 0, ela esta fechada.. assim okay deve ser 0 */
  /* se telaaberta for 1, ela esta aberta, temos que falar que */
  /* terminamos de scanear, com okay... tendo okay = 1 */
  
  if(i == (NUM_THREAD - 1)) {
  
    gtk_widget_hide(parar);
  
    if(telaaberta == 0)
      okay = 0;
    else
      okay = 1;

  }
}
int
aberta(int m)
{
  
  int i,j;
  char *texto[2], *trans, *descri;
  
  trans = malloc(50);
  bzero(trans, 50);
  sprintf(trans, "%d", m);
  texto[0] = trans;
  descri = descreve(m);
  texto[1] = descri;
  
  /* Soh coloca na lista.. se existir uma lista.. =) */
  
  if(telaaberta == 1)
    gtk_clist_append(GTK_CLIST (ctree), texto);
  
}

char *
descreve(int m)
{
  
  int k;
  
  for(k=0;k<1000;k++)
    if(descript[k].portanum == m)
      return descript[k].numdescri;
  
  return "-- No description for this service --";
}


